﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace ColumnChooserIssue
{
    public partial class Form1 : Form
    {
        DataTable _dtTable = new DataTable();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetUpGrid();
        }

        private void SetUpGrid()
        {
            _dtTable.Columns.Add("Column 0");
            _dtTable.Columns.Add("Column 1");
            _dtTable.Columns.Add("Column 2");
            _dtTable.Columns.Add("Column 3");
            _dtTable.Columns.Add("Column 4");

            DataRow dRow;
            for (int x = 0; x < 5; x++)
            {
                dRow = _dtTable.Rows.Add(new object[] { "Row" + x.ToString(), "Row" + x.ToString() + " Col 1", "Row" + x.ToString() + " Col 2", "Row" + x.ToString() + " Col 3", "Row" + x.ToString() + " Col 4" });
            }

            ultraGrid.DataSource = _dtTable;
        }

        private void ultraGrid_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.RowSelectorHeaderStyle = RowSelectorHeaderStyle.ColumnChooserButton;
            e.Layout.Bands[0].Columns["Column 2"].Hidden = true;
            e.Layout.Bands[0].SortedColumns.Add("Column 2", true, true);
        }

        private void ultraGrid_BeforeColumnChooserDisplayed(object sender, BeforeColumnChooserDisplayedEventArgs e)
        {
            e.Dialog.ColumnChooserControl.ColumnDisplayOrder = ColumnDisplayOrder.SameAsGrid;
            e.Dialog.DisposeOnClose = DefaultableBoolean.True; // this causes the Chooser to match the grid order on subsequent opens
        }

    }
}
